Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2894)
@@ -3676,5 +4018,5 @@
              TYPE( surf_type ) ::  surf_file   !< surface type on file
 
-             IF ( INDEX( TRIM( field_chr ), '%us' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%us' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%us )  .AND.                        &
                      ALLOCATED( surf_file%us   ) )                             & 
@@ -3682,5 +4024,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ol' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ol' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ol )  .AND.                        &
                      ALLOCATED( surf_file%ol   ) )                             & 
@@ -3688,5 +4030,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%pt_surface' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%pt_surface' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%pt_surface )  .AND.                &
                      ALLOCATED( surf_file%pt_surface   ) )                     & 
@@ -3694,5 +4036,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%usws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%usws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%usws )  .AND.                      &
                      ALLOCATED( surf_file%usws   ) )                           & 
@@ -3700,5 +4042,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%vsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%vsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%vsws )  .AND.                      &
                      ALLOCATED( surf_file%vsws   ) )                           & 
@@ -3706,5 +4048,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ts' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ts' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ts )  .AND.                        &
                      ALLOCATED( surf_file%ts   ) )                             & 
@@ -3712,5 +4054,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%shf' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%shf' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%shf )  .AND.                       &
                      ALLOCATED( surf_file%shf   ) )                            & 
@@ -3718,5 +4060,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qs )  .AND.                        &
                      ALLOCATED( surf_file%qs   ) )                             & 
@@ -3724,5 +4066,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qsws )  .AND.                      &
                      ALLOCATED( surf_file%qsws   ) )                           & 
@@ -3730,5 +4072,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ss' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ss' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ss )  .AND.                        &
                      ALLOCATED( surf_file%ss   ) )                             & 
@@ -3736,5 +4078,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ssws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ssws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ssws )  .AND.                      &
                      ALLOCATED( surf_file%ssws   ) )                           & 
@@ -3742,5 +4084,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%css' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%css' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%css )  .AND.                     &
                      ALLOCATED( surf_file%css   ) )  THEN                  
@@ -3750,5 +4092,5 @@
                 ENDIF
              ENDIF
-             IF ( INDEX( TRIM( field_chr ), '%cssws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%cssws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%cssws )  .AND.                     &
                      ALLOCATED( surf_file%cssws   ) )  THEN                  
@@ -3759,5 +4101,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qcs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qcs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qcs )  .AND.                       &
                      ALLOCATED( surf_file%qcs   ) )                            & 
@@ -3765,5 +4107,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qcsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qcsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qcsws )  .AND.                     &
                      ALLOCATED( surf_file%qcsws   ) )                          & 
@@ -3771,5 +4113,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ncs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ncs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ncs )  .AND.                       &
                      ALLOCATED( surf_file%ncs   ) )                            & 
@@ -3777,5 +4119,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%ncsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ncsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ncsws )  .AND.                     &
                      ALLOCATED( surf_file%ncsws   ) )                          & 
@@ -3783,5 +4125,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qrs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qrs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qrs )  .AND.                       &
                      ALLOCATED( surf_file%qrs   ) )                            & 
@@ -3789,5 +4131,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%qrsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qrsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qrsws )  .AND.                     &
                      ALLOCATED( surf_file%qrsws   ) )                          & 
@@ -3795,5 +4137,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%nrs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%nrs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%nrs )  .AND.                       &
                      ALLOCATED( surf_file%nrs   ) )                            & 
@@ -3801,5 +4143,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%nrsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%nrsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%nrsws )  .AND.                     &
                      ALLOCATED( surf_file%nrsws   ) )                          & 
@@ -3807,5 +4149,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%sasws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%sasws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%sasws )  .AND.                     &
                      ALLOCATED( surf_file%sasws   ) )                          & 
@@ -3813,5 +4155,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%mom_uv' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_uv' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_uv )  .AND.               &
                      ALLOCATED( surf_file%mom_flux_uv   ) )                    & 
@@ -3820,5 +4162,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%mom_w' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_w' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_w )  .AND.                &
                      ALLOCATED( surf_file%mom_flux_w   ) )                     & 
@@ -3827,5 +4169,5 @@
              ENDIF
 
-             IF ( INDEX( TRIM( field_chr ), '%mom_tke' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_tke' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_tke )  .AND.              &
                      ALLOCATED( surf_file%mom_flux_tke   ) )                   & 
@@ -3834,7 +4176,9 @@
              ENDIF
 
+
           END SUBROUTINE restore_surface_elements
 
-    END SUBROUTINE surface_read_restart_data
+
+    END SUBROUTINE surface_rrd_local
 
  
@@ -3903,5 +4247,5 @@
        REAL(wp), DIMENSION(:) ::  surf_target !< target surface type
        REAL(wp), DIMENSION(:) ::  surf_file   !< surface type on file
-       
+
        ic = nxlc
        DO  i = nxlf, nxrf
Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2894)
@@ -25,4 +25,14 @@
 ! -----------------
 ! $Id$
+! variable named found has been introduced for checking if restart data was found, 
+! reading of restart strings has been moved completely to read_restart_data_mod, 
+! redundant skipping function has been removed, stg_read/write_restart_data 
+! have been renamed to stg_r/wrd_global, stg_rrd_global is called in 
+! read_restart_data_mod now, flag syn_turb_gen_prerun and marker *** end stg
+! *** have been removed (Giersch), strings and their respective lengths are 
+! written out and read now in case of restart runs to get rid of prescribed 
+! character lengths (Giersch), CASE DEFAULT was added if restart data is read 
+! 
+! 2841 2018-02-27 15:02:57Z suehring
 ! Bugfix: wrong placement of include 'mpif.h' corrected
 ! 
@@ -44,5 +54,5 @@
 ! 
 ! 2576 2017-10-24 13:49:46Z Giersch
-! Definition of a new function called stg_skip_var_list to skip module 
+! Definition of a new function called stg_skip_global to skip module 
 ! parameters during reading restart data
 ! 
@@ -92,5 +102,5 @@
     USE control_parameters,                                                    &
         ONLY:  initializing_actions, message_string,                           &
-               syn_turb_gen, syn_turb_gen_prerun
+               syn_turb_gen
 
     USE cpulog,                                                                &
@@ -208,20 +218,14 @@
 
 !
-!-- Skipping of parameters for restart runs
-    INTERFACE stg_skip_var_list 
-       MODULE PROCEDURE stg_skip_var_list
-    END INTERFACE stg_skip_var_list
-
-!
 !-- Reading of parameters for restart runs
-    INTERFACE stg_read_restart_data
-       MODULE PROCEDURE stg_read_restart_data
-    END INTERFACE stg_read_restart_data
+    INTERFACE stg_rrd_global
+       MODULE PROCEDURE stg_rrd_global
+    END INTERFACE stg_rrd_global
 
 !
 !-- Writing of binary output for restart runs
-    INTERFACE stg_write_restart_data
-       MODULE PROCEDURE stg_write_restart_data
-    END INTERFACE stg_write_restart_data
+    INTERFACE stg_wrd_global
+       MODULE PROCEDURE stg_wrd_global
+    END INTERFACE stg_wrd_global
 
     SAVE
@@ -232,5 +236,5 @@
 !-- Public interfaces
     PUBLIC  stg_check_parameters, stg_header, stg_init, stg_main, stg_parin,   &
-            stg_write_restart_data, stg_skip_var_list
+            stg_wrd_global, stg_rrd_global
 
 !
@@ -702,35 +706,8 @@
     syn_turb_gen = .TRUE.
 
-    IF ( TRIM( initializing_actions ) == 'read_restart_data' ) THEN
-       CALL stg_read_restart_data
-    ENDIF
 
  10 CONTINUE
 
  END SUBROUTINE stg_parin
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Skipping the stg variables from restart-file (binary format).
-!------------------------------------------------------------------------------!
-   SUBROUTINE stg_skip_var_list 
-        
-      IMPLICIT NONE
-            
-      CHARACTER (LEN=1)  ::  cdum
-      CHARACTER (LEN=30) ::  variable_chr
-            
-      READ ( 13 )  variable_chr
-
-      DO  WHILE ( TRIM( variable_chr ) /= '*** end stg module ***' )
-
-         READ ( 13 )  cdum
-         READ ( 13 )  variable_chr
-
-      ENDDO   
-            
-   END SUBROUTINE stg_skip_var_list 
 
 
@@ -740,31 +717,34 @@
 !> This routine reads the respective restart data.
 !------------------------------------------------------------------------------!
- SUBROUTINE stg_read_restart_data
+ SUBROUTINE stg_rrd_global( found )
+
+
+    USE control_parameters,                                                    &
+        ONLY: length, restart_string
 
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=30) ::  variable_chr  !< dummy variable to read string
-
-
-    READ ( 13 )  variable_chr
-    DO  WHILE ( TRIM( variable_chr ) /= '*** end stg module ***' )
-
-       SELECT CASE ( TRIM( variable_chr ) )
-
-          CASE ( 'use_syn_turb_gen' )
-             READ ( 13 )  use_syn_turb_gen
-          CASE ( 'mc_factor' )
-             READ ( 13 )  mc_factor
-          CASE ( 'syn_turb_gen_prerun' )
-             READ ( 13 )  syn_turb_gen_prerun
-
-       END SELECT
-
-       READ ( 13 )  variable_chr
-
-    ENDDO
-
- END SUBROUTINE stg_read_restart_data
+    LOGICAL, INTENT(OUT)  ::  found 
+
+
+    found = .TRUE.
+ 
+
+    SELECT CASE ( restart_string(1:length) )
+
+       CASE ( 'mc_factor' )
+          READ ( 13 )  mc_factor
+       CASE ( 'use_syn_turb_gen' )
+          READ ( 13 )  use_syn_turb_gen
+
+       CASE DEFAULT
+
+          found = .FALSE.   
+
+    END SELECT
+
+
+ END SUBROUTINE stg_rrd_global
 
 
@@ -774,21 +754,18 @@
 !> This routine writes the respective restart data.
 !------------------------------------------------------------------------------!
- SUBROUTINE stg_write_restart_data
+ SUBROUTINE stg_wrd_global
 
 
     IMPLICIT NONE
 
-    syn_turb_gen_prerun = .TRUE.
-
-    WRITE ( 14 )  'use_syn_turb_gen              '
+
+    CALL wrd_write_string( 'mc_factor' )
+    WRITE ( 14 )  mc_factor
+
+    CALL wrd_write_string( 'use_syn_turb_gen' )
     WRITE ( 14 )  use_syn_turb_gen
-    WRITE ( 14 )  'mc_factor                     '
-    WRITE ( 14 )  mc_factor
-    WRITE ( 14 )  'syn_turb_gen_prerun           '
-    WRITE ( 14 )  syn_turb_gen_prerun
-
-    WRITE ( 14 )  '*** end stg module ***        '
-
-END SUBROUTINE stg_write_restart_data
+
+
+ END SUBROUTINE stg_wrd_global
 
 
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2894)
@@ -26,4 +26,18 @@
 ! -----------------
 ! $Id$
+! Calculations of the index range of the subdomain on file which overlaps with
+! the current subdomain are already done in read_restart_data_mod,
+! usm_read/write_restart_data have been renamed to usm_r/wrd_local, variable 
+! named found has been introduced for checking if restart data was found, 
+! reading of restart strings has been moved completely to 
+! read_restart_data_mod, usm_rrd_local is already inside the overlap loop 
+! programmed in read_restart_data_mod, SAVE attribute added where necessary, 
+! deallocation and allocation of some arrays have been changed to take care of 
+! different restart files that can be opened (index i), the marker *** end usm 
+! *** is not necessary anymore, strings and their respective lengths are 
+! written out and read now in case of restart runs to get rid of prescribed 
+! character lengths
+! 
+! 2805 2018-02-14 17:00:09Z suehring
 ! Initialization of resistances.
 ! 
@@ -711,7 +725,7 @@
     END INTERFACE usm_temperature_near_surface
 
-    INTERFACE usm_read_restart_data 
-       MODULE PROCEDURE usm_read_restart_data
-    END INTERFACE usm_read_restart_data
+    INTERFACE usm_rrd_local 
+       MODULE PROCEDURE usm_rrd_local
+    END INTERFACE usm_rrd_local
 
     INTERFACE usm_surface_energy_balance
@@ -723,7 +737,7 @@
     END INTERFACE usm_swap_timelevel
         
-    INTERFACE usm_write_restart_data
-       MODULE PROCEDURE usm_write_restart_data
-    END INTERFACE usm_write_restart_data
+    INTERFACE usm_wrd_local
+       MODULE PROCEDURE usm_wrd_local
+    END INTERFACE usm_wrd_local
 
     INTERFACE usm_allocate_surface
@@ -742,9 +756,9 @@
 !-- Public functions
     PUBLIC usm_boundary_condition, usm_check_parameters, usm_init_urban_surface,&
-           usm_read_restart_data,                                               & 
+           usm_rrd_local,                                                       & 
            usm_surface_energy_balance, usm_material_heat_model,                 &
            usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,      &
            usm_data_output_3d, usm_define_netcdf_grid, usm_parin,               &
-           usm_write_restart_data, usm_allocate_surface
+           usm_wrd_local, usm_allocate_surface
 
 !-- Public parameters, constants and initial values
@@ -5196,28 +5210,26 @@
 ! Description:
 ! ------------
-!> Soubroutine reads t_surf and t_wall data from restart files
+!> Soubroutine reads t_surf and t_wall data from restart file(s)
 !kanani: Renamed this routine according to corresponging routines in PALM
-!kanani: Modified the routine to match read_var_list, from where usm_read_restart_data
+!kanani: Modified the routine to match rrd_global, from where usm_rrd_local
 !        shall be called in the future. This part has not been tested yet. (see virtual_flight_mod)
 !        Also, I had some trouble with the allocation of t_surf, since this is a pointer.
 !        So, I added some directives here.
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_read_restart_data( ii,                                      &
-                                      nxlfa, nxl_on_file, nxrfa, nxr_on_file,  &
-                                      nynfa, nyn_on_file, nysfa, nys_on_file,  &
-                                      offset_xa, offset_ya, overlap_count )
-
-
-       USE pegrid,                                                             &
-           ONLY: numprocs_previous_run
+    SUBROUTINE usm_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,       &
+                              nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,&
+                              nys_on_file, found )
+
+
+       USE control_parameters,                                                 &
+           ONLY: length, restart_string
            
        IMPLICIT NONE
 
        CHARACTER (LEN=1)  ::  dum              !< dummy to create correct string for reading input variable
-       CHARACTER (LEN=30) ::  field_chr        !< input variable
 
        INTEGER(iwp)       ::  l                !< index variable for surface type
-       INTEGER(iwp)       ::  ii               !< running index over input files
-       INTEGER(iwp)       ::  kk               !< running index over previous input files covering current local domain
+       INTEGER(iwp)       ::  i                !< running index over input files
+       INTEGER(iwp)       ::  k                !< running index over previous input files covering current local domain
        INTEGER(iwp)       ::  ns_h_on_file_usm !< number of horizontal surface elements (urban type) on file
        INTEGER(iwp)       ::  nxlc             !< index of left boundary on current subdomain
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2894)
@@ -7356,12 +7435,14 @@
 ! Description:
 ! ------------
-!> Subroutine writes t_surf and t_wall data into restart files
+!> Subroutine writes t_surf and t_wall data into restart files. It is necessary
+!> to write start_index and end_index several times
 !kanani: Renamed this routine according to corresponging routines in PALM
-!kanani: Modified the routine to match write_var_list, from where usm_write_restart_data
+!kanani: Modified the routine to match wrd_global, from where usm_wrd_local
 !        shall be called in the future. This part has not been tested yet. (see virtual_flight_mod)
 !        Also, I had some trouble with the allocation of t_surf, since this is a pointer.
 !        So, I added some directives here.
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_write_restart_data
+    SUBROUTINE usm_wrd_local
+
     
        IMPLICIT NONE
@@ -7369,62 +7450,85 @@
        CHARACTER(LEN=1) ::  dum     !< dummy string to create output-variable name  
        INTEGER(iwp)     ::  l       !< index surface type orientation
+
+       CALL wrd_write_string( 'ns_h_on_file_usm' )
+       WRITE ( 14 )  surf_usm_h%ns
+
+       CALL wrd_write_string( 'ns_v_on_file_usm' )
+       WRITE ( 14 )  surf_usm_v(0:3)%ns
+
+       CALL wrd_write_string( 'usm_start_index_h' )
+       WRITE ( 14 )  surf_usm_h%start_index
+
+       CALL wrd_write_string( 'usm_end_index_h' )
+       WRITE ( 14 )  surf_usm_h%end_index
+
+       CALL wrd_write_string( 't_surf_h' )
+       WRITE ( 14 )  t_surf_h
+
+       CALL wrd_write_string( 't_surf_window_h' )
+       WRITE ( 14 )  t_surf_window_h
+
+       CALL wrd_write_string( 't_surf_green_h' )
+       WRITE ( 14 )  t_surf_green_h
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'usm_start_index_v' )
+          WRITE ( 14 )  surf_usm_v(l)%start_index
+
+          CALL wrd_write_string( 'usm_end_index_v' )
+          WRITE ( 14 )  surf_usm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l          
+
+          CALL wrd_write_string( 't_surf_v(' // dum // ')' )
+          WRITE ( 14 )  t_surf_v(l)%t
+
+          CALL wrd_write_string( 't_surf_window_v(' // dum // ')' )
+          WRITE ( 14 ) t_surf_window_v(l)%t     
+
+          CALL wrd_write_string( 't_surf_green_v(' // dum // ')' )
+          WRITE ( 14 ) t_surf_green_v(l)%t    
+          
+       ENDDO
+
+       CALL wrd_write_string( 'usm_start_index_h' )
+       WRITE ( 14 )  surf_usm_h%start_index
+
+       CALL wrd_write_string( 'usm_end_index_h' )
+       WRITE ( 14 )  surf_usm_h%end_index
+
+       CALL wrd_write_string( 't_wall_h' )
+       WRITE ( 14 )  t_wall_h
+
+       CALL wrd_write_string( 't_window_h' )
+       WRITE ( 14 )  t_window_h
+
+       CALL wrd_write_string( 't_green_h' )
+       WRITE ( 14 )  t_green_h
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'usm_start_index_v' )
+          WRITE ( 14 )  surf_usm_v(l)%start_index
+
+          CALL wrd_write_string( 'usm_end_index_v' )
+          WRITE ( 14 )  surf_usm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l     
+
+          CALL wrd_write_string( 't_wall_v(' // dum // ')' )
+          WRITE ( 14 )  t_wall_v(l)%t
+
+          CALL wrd_write_string( 't_window_v(' // dum // ')' )
+          WRITE ( 14 )  t_window_v(l)%t
+
+          CALL wrd_write_string( 't_green_v(' // dum // ')' )
+          WRITE ( 14 )  t_green_v(l)%t
        
-       WRITE ( 14 ) 'ns_h_on_file_usm              '
-       WRITE ( 14 ) surf_usm_h%ns
-       WRITE ( 14 ) 'ns_v_on_file_usm              '
-       WRITE ( 14 ) surf_usm_v(0:3)%ns
+       ENDDO
+
        
-       WRITE ( 14 ) 'usm_start_index_h             '
-       WRITE ( 14 ) surf_usm_h%start_index
-       WRITE ( 14 ) 'usm_end_index_h               '
-       WRITE ( 14 ) surf_usm_h%end_index
-       WRITE ( 14 ) 't_surf_h                      '
-       WRITE ( 14 ) t_surf_h
-       WRITE ( 14 ) 't_surf_window_h               '
-       WRITE ( 14 ) t_surf_window_h
-       WRITE ( 14 ) 't_surf_green_h                '
-       WRITE ( 14 ) t_surf_green_h
-       
-       DO  l = 0, 3
-          WRITE ( 14 ) 'usm_start_index_v             '
-          WRITE ( 14 ) surf_usm_v(l)%start_index
-          WRITE ( 14 ) 'usm_end_index_v               '
-          WRITE ( 14 ) surf_usm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 ) 't_surf_v(' // dum // ')                   ' 
-          WRITE ( 14 ) t_surf_v(l)%t          
-          WRITE ( 14 ) 't_surf_window_v(' // dum // ')            ' 
-          WRITE ( 14 ) t_surf_window_v(l)%t          
-          WRITE ( 14 ) 't_surf_green_v(' // dum // ')             ' 
-          WRITE ( 14 ) t_surf_green_v(l)%t          
-       ENDDO
-
-       WRITE ( 14 ) 'usm_start_index_h             '
-       WRITE ( 14 ) surf_usm_h%start_index
-       WRITE ( 14 ) 'usm_end_index_h               '
-       WRITE ( 14 ) surf_usm_h%end_index
-       WRITE ( 14 ) 't_wall_h                      '
-       WRITE ( 14 ) t_wall_h
-       WRITE ( 14 ) 't_window_h                    '
-       WRITE ( 14 ) t_window_h
-       WRITE ( 14 ) 't_green_h                     '
-       WRITE ( 14 ) t_green_h
-       DO  l = 0, 3
-          WRITE ( 14 ) 'usm_start_index_v             '
-          WRITE ( 14 ) surf_usm_v(l)%start_index
-          WRITE ( 14 ) 'usm_end_index_v               '
-          WRITE ( 14 ) surf_usm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 )  't_wall_v(' // dum // ')                   ' 
-          WRITE ( 14 )  t_wall_v(l)%t          
-          WRITE ( 14 )  't_window_v(' // dum // ')                 ' 
-          WRITE ( 14 )  t_window_v(l)%t          
-          WRITE ( 14 )  't_green_v(' // dum // ')                  ' 
-          WRITE ( 14 )  t_green_v(l)%t          
-       ENDDO
-
-       WRITE ( 14 )  '*** end usm ***               '
-       
-    END SUBROUTINE usm_write_restart_data
+    END SUBROUTINE usm_wrd_local
 
 !
Index: palm/trunk/SOURCE/user_last_actions.f90
===================================================================
--- palm/trunk/SOURCE/user_last_actions.f90	(revision 2893)
+++ palm/trunk/SOURCE/user_last_actions.f90	(revision 2894)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Writing of user-defined restart data will be done in an own module called
+! user_write_restart_data_mod 
+! 
+! 2718 2018-01-02 08:49:38Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -66,14 +70,6 @@
 
 !
-!-- Here the user-defined actions at the end of a job follow.
-!-- Sample for user-defined output:
-    IF ( write_binary )  THEN
-!       IF ( ALLOCATED( u2_av ) )  THEN
-!          WRITE ( 14 )  'u2_av               ';  WRITE ( 14 )  u2_av
-!       ENDIF
+!-- Here the user-defined actions at the end of a job might follow.
 
-       WRITE ( 14 )  '*** end user ***    '
-
-    ENDIF
 
  END SUBROUTINE user_last_actions
Index: palm/trunk/SOURCE/user_module.f90
===================================================================
--- palm/trunk/SOURCE/user_module.f90	(revision 2893)
+++ palm/trunk/SOURCE/user_module.f90	(revision 2894)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! An example for a user defined global variable has been added (Giersch)
+! 
+! 2718 2018-01-02 08:49:38Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -82,4 +85,6 @@
 !
 !-- Sample for user-defined output
+!    REAL(wp) :: global_parameter !< user defined global parameter 
+!
 !    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u2       !< user defined array
 !    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u2_av    !< user defined array
